import unittest
from my_sum import Calculator

class TestCalculator(unittest.TestCase):
    def test_add(self):
        self.assertEqual(Calculator.sum(2, 3), 5)
        self.assertEqual(Calculator.sum(5, 7), 12)
        self.assertEqual(Calculator.sum(-1, 1), 0)
        self.assertEqual(Calculator.sum(-1, -1), -2)
        self.assertEqual(Calculator.sum(0, 0), 0)
        self.assertEqual(Calculator.sum(0, 1), 1)
        
    def test_multiply(self):
        self.assertEqual(Calculator.multiply(2, 3), 6)
        self.assertEqual(Calculator.multiply(5, 7), 35)
        self.assertEqual(Calculator.multiply(-1, 1), -1)
        self.assertEqual(Calculator.multiply(-1, -1), 1)
        self.assertEqual(Calculator.multiply(0, 0), 0)
        
    def test_divide(self):
        self.assertEqual(Calculator.divide(6, 2), 3)
        self.assertEqual(Calculator.divide(10, 2), 5)
        self.assertEqual(Calculator.divide(5, 1), 5)
        self.assertEqual(Calculator.divide(0, 1), 0)
        self.assertEqual(Calculator.divide(0, 2), 0)
        
    def test_subtract(self):
        self.assertEqual(Calculator.subtract(2, 3), -1)
        self.assertEqual(Calculator.subtract(5, 7), -2)
        self.assertEqual(Calculator.subtract(-1, 1), -2)
        self.assertEqual(Calculator.subtract(-1, -1), 0)
        
if __name__ == '__main__':
    unittest.main()